let stepPression=0;
let nElec=2;
let oSens={nMax:50,vPA0:0,vPA1:0,tpsPA:0,isPA:false,tpsPA0:0,isPA0:false,dureePA:100};
let oMoto={nMax:40,tpsPA:0,isPA:false,dureePA:100};
let oPol={v:-70,seuil:-35,repos:-70,arrivePA:false,nVal:800,isPA:false,tPA:0,dureePA:80}
 
let tPA = [-70,-63,-50,-30,0,35,10,-20,-40,-58,-70,-78,-80,-78,-74,-72,-71,-70];
let tPAcourt = [-30,0,35,10,-20,-40,-58,-70,-78,-80,-78,-74,-72,-71,-70];
 
function initPa() {
	oSens.tPA=[];
	for (let i=0;i<oSens.nMax;i++) {
		oSens.tPA.push(false);
	}
	oMoto.tPA=[];
	for (let i=0;i<oMoto.nMax;i++) {
		oMoto.tPA.push(false);
	}
}

function tracePASens () {
	let rect=divPASens.getBoundingClientRect();
	let h=rect.height;
	let r=h*0.4;
	let l=rect.width-r*4;
	let d=r*2;
	let y=h/2;
	let espace=l/(oSens.nMax-1);
	let dx=(frame%pas)*espace/pas;
	canvPASens.width=rect.width;
	canvPASens.height=rect.height;
	let ctx = canvPASens.getContext('2d');
	ctx.fillStyle="rgba(255,200,0,0.5)";
	ctx.strokeStyle="rgba(127,0,0,0.5)";
	for (let i=0;i<oSens.nMax;i++) {
		let x=i*espace+r+dx;
		if (oSens.tPA[i]) {
			//ctx.fillRect(x,y-r,d,d);
			ctx.beginPath();
			ctx.arc(x,y,r,0,Math.PI*2);
			ctx.closePath();
			ctx.fill();
			ctx.stroke();
		}
	}
}

function tracePAMoto () {
	let rect=divPAMoto.getBoundingClientRect();
	let h=rect.height;
	let r=h*0.4;
	let l=rect.width-r*4;
	let d=r*2;
	let y=h/2;
	let espace=l/(oMoto.nMax-1);
	let dx=(frame%pas)*espace/pas;
	canvPAMoto.width=rect.width;
	canvPAMoto.height=rect.height;
	let ctx = canvPAMoto.getContext('2d');
	ctx.fillStyle="rgba(255,200,0,0.5)";
	ctx.strokeStyle="rgba(127,0,0,0.5)";
	for (let i=0;i<oMoto.nMax;i++) {
		let x=i*espace+r+dx;
		if (oMoto.tPA[i]) {
			//ctx.fillRect(x,y-r,d,d);
			ctx.beginPath();
			ctx.arc(x,y,r,0,Math.PI*2);
			ctx.closePath();
			ctx.fill();
			ctx.stroke();
		}
	}
}

function avancePASens () {
	oPol.arrivePA=oSens.tPA.pop();
	if (modeStim==1) {
		oSens.tPA.unshift(false);
		if (hasStim) {
			oSens.tPA[Math.round(oSens.nMax*0.112)]=true;
		}
	} else {
		let genPA=false;
		stepPression++
		let seuil;
		if (pression<0.02) {
			seuil=1000000000;
		} else if (pression<0.04) {
			seuil=6;
		} else if (pression<0.06) {
			seuil=5;
		} else if (pression<0.1) {
			seuil=4;
		} else if (pression<0.15) {
			seuil=3;
		} else if (pression<0.2) {
			seuil=2;
		} else {
			seuil=1;
		}
		if (stepPression>=seuil) {
			genPA=true;
			stepPression=0;
		}
		oSens.tPA.unshift(genPA);
	}
	hasStim=false;
}

function avancePAMoto () {
	oMoto.arrivePA=oMoto.tPA.pop();
	oMuscle.contracte=oMoto.arrivePA;
	let nextPA=(oPol.isPA)&&(!oMoto.tPA[0]);
	oMoto.tPA.unshift(nextPA);
}

function initPol () {
	oPol.v=oPol.repos;
	oPol.tVal=[];
	for (let i=0;i<oPol.nVal;i++) {
		oPol.tVal.push(99);
	}
}

function calcPol () {
	if (oPol.isPA) {
		let iPA=oPol.tPA/oPol.dureePA*(tPAcourt.length-1);
		let i0=Math.floor (iPA);
		let i1=Math.ceil (iPA);
		let ir=iPA-i0;
		let irr=1-ir;
		let v0=tPAcourt[i0];
		let v1=tPAcourt[i1];
		let valPA=v0*irr+v1*ir;
		oPol.tPA+=100/pas;
		if (oPol.tPA>oPol.dureePA) {
			oPol.isPA=false;
		}
		oPol.v=valPA;
	} else {
		let iPas=frame%pas;
		if (oPol.arrivePA) {
			let angle=iPas/pas*Math.PI*2-Math.PI/2;
			oPol.v+=(Math.sin(angle)+1)*15/pas;
			if (oPol.v>oPol.seuil) {
				oPol.isPA=true;
				oPol.tPA=0;
			}
		} else {
			oPol.v-=3/pas;
		}
		if (oPol.v<oPol.repos) {
			oPol.v=oPol.repos;
		}
	}
	oPol.tVal.pop();
	
	oMoto.v=oPol.repos;
	if (oMoto.isPA) {
		let iPA=oMoto.tpsPA/oMoto.dureePA*(tPA.length-1);
		let i0=Math.floor (iPA);
		let i1=Math.ceil (iPA);
		let ir=iPA-i0;
		let irr=1-ir;
		let v0=tPA[i0];
		let v1=tPA[i1];
		let valPA=v0*irr+v1*ir;
		oMoto.tpsPA+=100/pas;
		if (oMoto.tpsPA>oMoto.dureePA) {
			oMoto.isPA=false;
		}
		oMoto.v=valPA;
	} else {
		if (oMoto.tPA[Math.round(oMoto.nMax*0.48)]) {
			oMoto.isPA=true;
			oMoto.tpsPA=0;
		}
	}
	
	oSens.v0=oPol.repos;
	if (oSens.isPA0) {
		let iPA=oSens.tpsPA0/oSens.dureePA*(tPA.length-1);
		let i0=Math.floor (iPA);
		let i1=Math.ceil (iPA);
		let ir=iPA-i0;
		let irr=1-ir;
		let v0=tPA[i0];
		let v1=tPA[i1];
		let valPA=v0*irr+v1*ir;
		oSens.tpsPA0+=100/pas;
		if (oSens.tpsPA0>oSens.dureePA) {
			oSens.isPA0=false;
		}
		oSens.v0=valPA;
	} else {
		if (oSens.tPA[Math.round(oSens.nMax*0.26)]) {
			oSens.isPA0=true;
			oSens.tpsPA0=0;
		}
	}
	
	oSens.v1=oPol.repos;
	if (oSens.isPA1) {
		let iPA=oSens.tpsPA1/oSens.dureePA*(tPA.length-1);
		let i0=Math.floor (iPA);
		let i1=Math.ceil (iPA);
		let ir=iPA-i0;
		let irr=1-ir;
		let v0=tPA[i0];
		let v1=tPA[i1];
		let valPA=v0*irr+v1*ir;
		oSens.tpsPA1+=100/pas;
		if (oSens.tpsPA1>oSens.dureePA) {
			oSens.isPA1=false;
		}
		oSens.v1=valPA;
	} else {
		if (oSens.tPA[Math.round(oSens.nMax*0.67)]) {
			oSens.isPA1=true;
			oSens.tpsPA1=0;
		}
	}
	
	if (nElec==2) {
		oPol.tVal.unshift(oPol.v);
	} else if (nElec==3) {
		oPol.tVal.unshift(oMoto.v);
	} else if (nElec==0) {
		oPol.tVal.unshift(oSens.v0);
	} else if (nElec==1) {
		oPol.tVal.unshift(oSens.v1);
	}
}

function traceSynapse () {
	let rect=divSynapseNN.getBoundingClientRect();
	let h=rect.height;
	let l=rect.width;
	let y0=h/2;
	let x0=l/2;
	let r0=h*0.4;
	let r2=r0/20;
	let d2=r2*2;
	canvSynapseNN.width=rect.width;
	canvSynapseNN.height=rect.height;
	let ctx = canvSynapseNN.getContext('2d');
	if (oPol.arrivePA) {
		let iPas=frame%pas;
		let angle=iPas/pas*Math.PI*2-Math.PI/2;
		let v=Math.sin(angle)*100;
		ctx.fillStyle="#FFAA00";
		for (let i=0;i<v;i++) {
			let a=Math.random()*Math.PI*2;
			let r=Math.pow(Math.random(),0.8)*r0;
			let x=x0+Math.cos(a)*r-r2;
			let y=y0+Math.sin(a)*r-r2;
			ctx.fillRect(x,y,d2,d2);
		}
	}
}

function traceSynapseNM () {
	let rect=divSynapseNM.getBoundingClientRect();
	let h=rect.height;
	let l=rect.width;
	let y0=h/2;
	let x0=l/2;
	let r0=h*0.4;
	let r2=r0/20;
	let d2=r2*2;
	canvSynapseNM.width=rect.width;
	canvSynapseNM.height=rect.height;
	let ctx = canvSynapseNM.getContext('2d');
	if (oMoto.arrivePA) {
		let iPas=frame%pas;
		let angle=iPas/pas*Math.PI*2-Math.PI/2;
		let v=Math.sin(angle)*100;
		ctx.fillStyle="#FFAA00";
		for (let i=0;i<v;i++) {
			let a=Math.random()*Math.PI*2;
			let r=Math.pow(Math.random(),0.8)*r0;
			let x=x0+Math.cos(a)*r-r2;
			let y=y0+Math.sin(a)*r-r2;
			ctx.fillRect(x,y,d2,d2);
		}
	}
}

function selElec(n) {
	nElec=n;
	initPol();
	for (let i=0;i<4;i++) {
		byId("divElectrodes"+i).style.opacity=0.2;
	}
	byId("divElectrodes"+n).style.opacity=1;
	traceFils();
}



